#include <avr/pgmspace.h>
#include <avr/interrupt.h>
#include <avr/iom16.h>
#include <stdlib.h>


#define SET_B(x) |=(1<<x)  // ""  
#define CLR_B(x) &=~(1<<x)  // ""  
#define INV_B(x) ^=(1<<x)   //  

#define ADC_VREF_TYPE 0x20

#define cycle 4

#define OUT_PORT PORTB

volatile unsigned char U[2];
//             				00010000   01000000   00100000   10000000   10000000
    char mask[4] PROGMEM = {0b01010000,0b01100000,0b10100000,0b10010000};//,0b10010000}; byte = pgm_read_byte(&(mydata[i][j]));
//          				01000000   00100000   10000000   00010000   00010000
//              . .  .      . C2    Cx
    volatile int nstep;
    volatile int crazr;
    volatile int a;


// Timer 0 overflow interrupt service routine
ISR(TIMER0_OVF_vect)
{
// Place your code here
 TIMSK CLR_B(0);  //  0
 PORTA CLR_B(6);  //   -  PA6  "0"
 ADCSRA|=0x40;
 PORTA SET_B(7);  // ADC - PA7 "1"

 return;
}

// Timer 0 output compare interrupt service routine
/*ISR(TIMER0_COMP_vect)
{
// Place your code here
 TIMSK CLR_B(0);  //   . 0
 PORTA CLR_B(6);
 ADCSRA|=0x40;
 PORTA SET_B(7);
 return;
}  */



// Timer 1 overflow interrupt service routine
ISR(TIMER1_OVF_vect)
{
PORTB=PORTB^(pgm_read_byte(&(mask[nstep]))); //    -  
TCNT1H=0xFF;  //
TCNT1L=0xD7;  //   T=80   ffd7
nstep++;

             if (nstep == 2)   // ,      
                 {
                     crazr++;
                        if ((crazr >= 23)&&!(ADCSRA & (1<<6)))  //       23 ( -  22 (?))...
                            { PORTA SET_B(6);                   //     
		TCNT0 = 0;
		TIFR SET_B(0);      //    0  .,    
		TIMSK SET_B(0);     //   . 0
                                                 // delay    0
		TCNT0 = 160;          // 2*(255-160)=190  (2=1/500)
                           };                     //   190    0
                 };

if (nstep == cycle)
      {
        nstep=0;
      };
}

// ADC interrupt service routine
ISR(ADC_vect)
{
//volatile unsigned char adc_data;
// Read the 8 most significant bits
// of the AD conversion result
      PORTA CLR_B(7); // ADC  - PA7 "0"
      U[a] = ADC;
      ADMUX INV_B(0); // ..   2 ,     ;    , .  /*lcd_gotoxy(0,a);
      a++;
      if (a==2)
        {
         a = 0;
         crazr = 0;
         TIMSK CLR_B(2);  //  1
                          //       ,
                          //      ,     calc_c()
         return;
        };

}
// Declare your global variables here

void calc_C(void)
{
nstep=0;
crazr=0;
a=0;
PORTD=0b00110000;
PORTB=0b00010000; //        Cx
     SFIOR SET_B(0);  //  

     TCNT1H=0xFF;
     TCNT1L=0xD7;   //   1  .       B     
     TIMSK SET_B(2); //  Timer1, Bit 2  TOIE1: Timer/Counter1, Overflow Interrupt Enable

do {
   }
while (TIMSK & (1<<2)); //   1 ...
PORTA INV_B(5);         //...  ,  .

}

void main(void)
{
// Declare your local variables here

/* Reset */
__asm__ ("wdr");
/* Write logical one to WDTOE and WDE */
WDTCR |= (1 << 4) | (1 << 3);
WDTCR = 0x00;
// char string_1[] PROGMEM = "String 1";

/* Input/Output Ports initialization
 Port A initialization
 Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In
 State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T   */
PORTA=0b00000000;
DDRA=0b11100000;

/* Port B initialization
 Func7=Out Func6=Out Func5=Out Func4=Out Func3=In Func2=In Func1=Out Func0=In
 State7=0 State6=0 State5=0 State4=0 State3=T State2=T State1=0 State0=P        */
PORTB=0b00000000;
 DDRB=0b11110010; //       

/* Port C initialization
 Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In
 State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T  */
PORTC=0x00;
DDRC=0x00;

/* Port D initialization
 Func7=Out Func6=Out Func5=Out Func4=Out Func3=In Func2=In Func1=In Func0=In
 State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T  */
PORTD=0b00000000;
DDRD=0b11110000;

/* Timer/Counter 0 initialization
 Clock source: System Clock
 Clock value: 4000,000 kHz
 Mode: Normal top=FFh
 OC0 output: Disconnected   */
/* TCCR0 Timer/Counter Control Register
    _ _ _ _ _ CS02 CS01 CS00
 - - - - - - - - - - - - - - - - - - - - - - - -
   TCNT0 Timer/Counter Register
            TCNT0[7:0]
*/
TCCR0=0b00000010;   // 0 1 0  == (clkI/O)/8 (From prescaler)  -   0 = 500
TCNT0=0x00;
OCR0=0x5F;

/* Timer/Counter 1 initialization
 Clock source: System Clock
 Clock value: 4000,000 kHz
 Mode: Normal top=FFFFh
 OC1A output: Discon.
 OC1B output: Discon.
 Noise Canceler: Off
 Input Capture on Falling Edge
 Timer 1 Overflow Interrupt: On
 Input Capture Interrupt: Off
 Compare A Match Interrupt: Off
 Compare B Match Interrupt: Off   */
TCCR1A=0x00; // COM1A1 COM1A0 COM1B1 COM1B0 FOC1A FOC1B WGM11 WGM10
TCCR1B=0b000000010; // ICNC1 ICES1  WGM13 WGM12 CS12 CS11 CS10   0 1 0 clkI/O/8 (From prescaler) (500)
TCNT1H=0x00; //           0     0  0    0     0    0    1   0
TCNT1L=0x00;
ICR1H=0x00;
ICR1L=0x00;
OCR1AH=0x00;
OCR1AL=0x00;
OCR1BH=0x00;
OCR1BL=0x00;

/* Timer/Counter 2 initialization
 Clock source: System Clock			
 Clock value: Timer 2 Stopped
 Mode: Normal top=FFh
 OC2 output: Disconnected   */
ASSR=0x00;
TCCR2=0x00;
TCNT2=0x00;
OCR2=0x00;


/* External Interrupt(s) initialization
 INT0: Off
 INT1: Off
 INT2: Off */
MCUCR=0x00;
MCUCSR=0x00;

// Timer(s)/Counter(s) Interrupt(s) initialization
TIMSK=0x00;
/* TIMSK - Timer/Counter Interrupt Mask Register
    OCIE2 TOIE2 TICIE1 OCIE1A OCIE1B [TOIE1]  [TOIE0]
    0     0     0      0      0      1       0  1
Bit 0  TOIE0: Timer/Counter0 Overflow Interrupt Enable
Bit 2  TOIE1: Timer/Counter1, Overflow Interrupt Enable
Bit 4  OCIE1A: Timer/Counter1, Output Compare A Match Interrupt Enable
    - - - - - - - - - - - - - - - - - - - - - - - -
    TIFR - Timer/Counter Interrupt Flag Register
    OCF2 TOV2 ICF1 OCF1A OCF1B TOV1  TOV0
Bit 0  TOV0: Timer/Counter0 Overflow Flag     */

/* Analog Comparator initialization
 Analog Comparator: Off
 Analog Comparator Input Capture by Timer/Counter 1: Off    */
ACSR=0x80;
SFIOR=0x00;

/* ADC initialization
 ADC Clock frequency: 62,500 kHz
 ADC Voltage Reference: AREF pin
 ADC Auto Trigger Source: None
 Only the 8 most significant bits of
 the AD conversion result are used
 #define ADC_VREF_TYPE 0x20          */
ADMUX=ADC_VREF_TYPE & 0xff;  // ADMUX == 0b00100000
/*ADMUX:
 REFS1 REFS0 ADLAR  MUX3 MUX2 MUX1 MUX0
 0     0     1     0 0    0    0    0     REFS1==0 REFS0==0 - AREF, Internal Vref turned off
                                          ADLAR: ADC Left Adjust Result (1==Left => ADCH == 8bit)
                                          MUX3..0 == 0000 - ADC0
*/
ADCSRA=0x8E;                 // 0b10001110
/*     ADC Control and Status Register A  ADCSRA
                 ADEN ADSC ADFR ADIF ADIE ADPS2 ADPS1 ADPS0
             ADEN: ADC Enable
             ADSC: ADC Start Conversion
             ADFR: ADC Free Running Select
             ADIF: ADC Interrupt Flag
             ADIE: ADC Interrupt Enable
             ADPS2..0: ADC Prescaler Select Bits (These bits determine the division factor
                      between the XTAL frequency and the input clock to the ADC  (==64)
*/

// Global enable interrupts
__asm__ ("sei");

do {
calc_C();
   }
while (1);
}





